# CDR  & DVD backup
#
# We assume backup tree with colapse.awk utility.
# The size of compressed archives should be at most of size of the target 
# removable media. This will assure that splitted archive will span over 
# at most two disks. This recomendation is not obligatory for this utility.
# If you span archive over more disks, more time/disk space is needed for
# spliting. Again. Please note that there is 2^31 file size limitation!
# This mean that zip archive cannot span more than two DVD media!
#    Small archives are only symbolicly linked. For creating real disk 
# images one should use symbolic link dereference with utility which
# will transfer files on media! For example use "du -L *" in created
# disk directories to verify that the largest disk will fit the media!
#    To prevent that archive will be splitted over two disks, with
# a small head on one disk and large tail on another the KEEP_TOGETHER 
# parameter assigns alowable space waste (tolerance) to be left on one disk
# just to keep things together (eg. 3% of disk). Please note that space
# waste occurs also in zipsplit utility. Als sizes are given in BYTES.
# I recommend starting with greedy 1% KEEP_TOGETHER and increasing it 
# until the number of disks required for whole backup is the same. If
# one wants to rely on zipsplit bin packing with no widow protection, it
# is also admissible to set KEEP_TOGETHER=0;
#
# author: (C) 2003, Leon Kos
# License: GPL
# usage: awk -f disk-split.awk
# OS: Linux
#
BEGIN {
#temporary storage of large zips created with colapse.awk
  SRC="/home/staff-backup";

#splitted zips for backup to CDR
  DST="/home/dvd-split";

  MB=1024*1024
  DISK_SIZE=700*MB; #CDR
  DISK_SIZE=4400*MB;#DVD

  KEEP_TOGETHER = DISK_SIZE/100*2; # Prevent widow archives
  
  FS="\t";

  system("rm -rf " DST "; mkdir " DST "; mkdir " DST "/disk00");
  
  disk=0;
  total_size = 0;

  findcmd = "find " SRC " -type f -name '*.zip' -print0 |" \
	" xargs -0 stat -f %z%t%N";
  
  while( (findcmd | getline) > 0)
    {

      size = $1;
      filename = $2;

      if ((total_size + size > DISK_SIZE) && (size >= KEEP_TOGETHER))
	{

	  
	  if (DISK_SIZE > 2^31) # zip and awk size limitation
	  {
	       cmdsplit = sprintf("zipsplit -n " 2^31 - 1 \
				" -r "  2^31 - 1 - (DISK_SIZE - total_size) \
			     " -b " DST "/disk%02d \"" filename"\"", disk); 
	  }
	  else
	    {
	       cmdsplit = sprintf("zipsplit -n " DISK_SIZE " -r " total_size \
			     " -b " DST "/disk%02d \"" filename"\"", disk); 
            }
	  
#	  print cmdsplit; 
	  cmdsplit | getline;
	  total_zips = $1;
	  
#	  print "Total of " total_zips " for " filename;

	  cmdsplit | getline;
	  sub("creating: ", ""); 

	  archive = 0;
	  
	  cmd = sprintf("mv \"" $0 "\" \"" DST "/disk%02d/" \
			mangle(filename) "." archive ".zip\"", disk);
#	  print cmd; 
	  system(cmd);

	  while ( (cmdsplit | getline) > 0) # should run only once
	    {
	      disk++;
	      archive ++;
	      cmd = sprintf("mkdir " DST "/disk%02d", disk); 
	      print cmd; system(cmd);

	      sub("creating: ", ""); 
# We need size for last disk to fill up
	      cmd = "stat -f %z " $0;
	      if( cmd | getline total_size == 1)
		close(cmd);
	      else
		exit(3);
	      
	      cmd = sprintf("mv \"" $0 "\" \"" DST "/disk%02d/" \
			    mangle(filename) "." archive ".zip\"", disk);
#	      print cmd; 
	      system(cmd);
	    }
	  close(cmdsplit); 
	}
      else # just link to original
	{
	  if ((total_size + size > DISK_SIZE) && (size < KEEP_TOGETHER))
	    {
	      disk ++;
	      cmd = sprintf("mkdir " DST "/disk%02d", disk);
	      system(cmd);
	      total_size = 0;
	      print "Widow protection for ", filename;
	    }

	  total_size += size;
	  cmd = sprintf("ln -s \"" filename "\" \"" \
			DST "/disk%02d/" mangle(filename) ".zip\"",  disk);
	  system(cmd);
#	  print size, cmd;
	}
    }
  close(findcmd);
  exit(0)
}

function mangle(filename)
{
  mangled = filename;
  sub(SRC, "", mangled);
  sub(DST, "", mangled);
  sub(/^\//,"", mangled);
  gsub(/\//, "-", mangled);
#  sub("#", ".", mangled);
  sub(/\.zip$/, "", mangled);
  return mangled;
}

